summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorDavid Malcolm <dmalcolm@redhat.com>2012-08-09 02:15:43 (GMT)
committerDavid Malcolm <dmalcolm@redhat.com>2012-08-09 02:15:43 (GMT)
commit4b2a8915cf06909568537feb2bbd3cbac392ee18 (patch)
tree5d4b8cc4cda27fe0117afd23f864c232b9a05f4b
parent2a14799f41be4e6f02d608ad374106a9ae304864 (diff)
downloadpygobject3-4b2a8915cf06909568537feb2bbd3cbac392ee18.zip
pygobject3-4b2a8915cf06909568537feb2bbd3cbac392ee18.tar.gz
pygobject3-4b2a8915cf06909568537feb2bbd3cbac392ee18.tar.xz
add a %check check; add V=1 to all make invocations
-rwxr-xr-xephemeral-x.sh186
-rw-r--r--ignore-more-pep8-errors.patch30
-rw-r--r--pygobject-3.3.4-known-failures.patch11
-rw-r--r--pygobject3.spec92
4 files changed, 314 insertions, 5 deletions
diff --git a/ephemeral-x.sh b/ephemeral-x.sh
new file mode 100755
index 0000000..43349a3
--- /dev/null
+++ b/ephemeral-x.sh
@@ -0,0 +1,186 @@
+#!/bin/sh
+# Start an ephemeral X server.
+#
+# This is useful for when you want to lauch an X server for a specific
+# process. When that process exits, the X server will be killed.
+#
+
+XSERVER=Xvfb
+WINMGR=
+
+prog=$0
+usage() {
+ echo "Usage: $prog [-x XSERVER] [-w WINDOWMANAGER] [-q] [-h] <command>"
+ echo "-h this help"
+ echo "-q quiet"
+ echo "-w window manager process to start once Xserver is up"
+ echo " (default: '$WINMGR')"
+ echo "-x Xserver (and args) to run"
+ echo " (default: '$XSERVER')"
+ echo
+ echo "This tool will pick an unused DISPLAY value (:0, :1, etc) and"
+ echo "start an Xserver on that display, then run your command."
+ echo
+ echo "Examples:"
+ echo " $prog -x 'Xephyr -screen 1280x720' xterm"
+ echo " $prog -x 'Xvnc -httpd /usr/share/vnc/classes -geometry 1024x768 -depth 24' -w "gnome-session" firefox"
+}
+
+quiet() {
+ [ "0$QUIET" -eq 1 ]
+}
+
+test_x_available() {
+ xsocket=$1
+ ! test -S $xsocket
+}
+
+test_x_healthy() {
+ xpid=$1
+ xsocket=$2
+ displaynum=$3
+
+ # Try xterm to see if X is up.
+ if which xterm > /dev/null 2>&1 ; then
+ DISPLAY=:$displaynum xterm -e 'true'
+ return $?
+ fi
+
+ # Try xdotool if available, if xterm is not.
+ if which xdotool > /dev/null 2>&1 ; then
+ DISPLAY=:$displaynum xdotool getmouselocation > /dev/null 2>&1
+ return $?
+ fi
+
+ # Try lsof if no X clients (above) are available
+ if which lsof > /dev/null 2>&1 ; then
+ lsof -p $xpid | grep -qF $xsocket
+ return $?
+ fi
+
+ echo "Unable to determine if X is healthy (no tools available)"
+ return false
+}
+
+cleanup() {
+ if [ ! -z "$winmgrpid" ] ; then
+ kill -TERM "$winmgrpid" || true
+ fi
+ kill -TERM "$xpid" || true
+
+ pkill -KILL -P $$ || true
+}
+
+eval "set -- $( (POSIXLY_CORRECT=1 getopt -s sh +x:w:qh "$@" || echo " "FAIL) | tr -d '\n' )"
+
+while [ "0$#" -gt 0 ] ; do
+ case $1 in
+ -x) XSERVER="$2"; shift ;;
+ -w) WINMGR="$2"; shift ;;
+ -q) QUIET=1 ;;
+ -h) usage; exit ;;
+ --) shift; break ;;
+ esac
+ shift
+done
+
+if [ "$1" = "FAIL" ] ; then
+ usage
+ exit 1
+fi
+
+num=-1
+XSERVERNAME=${XSERVER%% *}
+if ! which "$XSERVERNAME" > /dev/null 2>&1 ; then
+ echo "Unable to find $XSERVERNAME. Aborting."
+ cleanup
+ exit 1
+fi
+
+while true; do
+ num=$(expr $num + 1)
+ xsocket=/tmp/.X11-unix/X$num
+ quiet || echo "Trying :$num"
+ test_x_available $xsocket || continue
+ (
+ if quiet ; then
+ exec > /dev/null
+ exec 2> /dev/null
+ fi
+ echo set -- $XSERVER
+ set -- $XSERVER
+ cmd=$1
+ shift
+ exec $cmd :$num "$@"
+ ) &
+ xpid=$!
+
+ healthy=0
+ for i in 1 2 3 4 5 6 7 8 9 ; do
+ # Break early if the xserver died
+ #ps -p $xpid > /dev/null 2>&1 || break
+ kill -0 $xpid > /dev/null 2>&1 || break
+
+ # See if the xserver got a hold of the display socket.
+ # If so, the server is up and healthy.
+ sleep 1
+ if test_x_healthy $xpid $xsocket $num ; then
+ quiet || echo "$XSERVERNAME looks healthy. Moving on."
+ healthy=1
+ break
+ fi
+ sleep 0.2 || sleep 1 # In case your sleep doesn't take subsecond values
+ done
+
+ if [ "0$healthy" -eq 1 ] ; then
+ break
+ fi
+done
+
+export DISPLAY=:$num
+quiet || echo "Using display: $DISPLAY"
+
+if [ ! -z "$WINMGR" -a "$WINMGR" != "none" ] ; then
+ if ! which $WINMGR > /dev/null 2>&1 ; then
+ echo "Cannot find $WINMGR. Aborting."
+ cleanup
+ exit 1
+ fi
+ WINMGRNAME=${WINMGR%% *}
+ quiet || echo "Starting window manager: $WINMGRNAME"
+ (
+ if quiet ; then
+ exec > /dev/null
+ exec 2> /dev/null
+ fi
+ $WINMGR
+ ) &
+ winmgrpid=$!
+
+ # Wait for the window manager to startup
+ quiet || echo "Waiting for window manager '$WINMGRNAME' to be healthy."
+ # Wait for the window manager to start.
+ for i in 1 2 3 4 5 6 7 8 9 10 ABORT ; do
+ # A good signal that the WM has started is that the WM_STATE property is
+ # set or that any NETWM/ICCCM property is set.
+ if xprop -root | egrep -q 'WM_STATE|^_NET' ; then
+ quiet || echo "$WINMGRNAME looks healthy. Moving on."
+ break;
+ fi
+ sleep .5
+
+ if [ "$i" = "ABORT" ] ; then
+ quiet || echo "Window manager ($WINMGRNAME) seems to have failed starting up."
+ cleanup
+ exit 1
+ fi
+ done
+fi
+
+quiet || echo "Running: $@"
+(
+ "$@"
+)
+exitcode=$?
+cleanup
+exit $exitcode
diff --git a/ignore-more-pep8-errors.patch b/ignore-more-pep8-errors.patch
new file mode 100644
index 0000000..9fd6ba6
--- /dev/null
+++ b/ignore-more-pep8-errors.patch
@@ -0,0 +1,30 @@
+diff -up pygobject-3.3.4/tests/Makefile.am.ignore-more-pep8-errors pygobject-3.3.4/tests/Makefile.am
+--- pygobject-3.3.4/tests/Makefile.am.ignore-more-pep8-errors 2012-06-22 07:16:12.000000000 -0400
++++ pygobject-3.3.4/tests/Makefile.am 2012-08-08 18:00:56.132870559 -0400
+@@ -107,9 +107,9 @@ RUN_TESTS_ENV_VARS= \
+
+ check-local: $(LTLIBRARIES:.la=.so) Regress-1.0.typelib GIMarshallingTests-1.0.typelib gschemas.compiled
+ @echo " CHECK Pyflakes"
+- @pyflakes $(top_srcdir)
++ pyflakes $(top_srcdir)
+ @echo " CHECK PEP8"
+- @pep8 --ignore=E501,E123 --repeat --show-source $(top_srcdir)
++ pep8 --ignore=E501,E123,E124,E127 --repeat --show-source $(top_srcdir)
+ $(RUN_TESTS_ENV_VARS) $(DBUS_LAUNCH) $(EXEC_NAME) $(PYTHON) -Wd -Werror::PendingDeprecationWarning -Werror::DeprecationWarning $(srcdir)/runtests.py
+
+ check.gdb:
+diff -up pygobject-3.3.4/tests/Makefile.in.ignore-more-pep8-errors pygobject-3.3.4/tests/Makefile.in
+--- pygobject-3.3.4/tests/Makefile.in.ignore-more-pep8-errors 2012-08-08 18:08:37.813838989 -0400
++++ pygobject-3.3.4/tests/Makefile.in 2012-08-08 18:08:50.877838097 -0400
+@@ -725,9 +725,9 @@ clean-local:
+
+ check-local: $(LTLIBRARIES:.la=.so) Regress-1.0.typelib GIMarshallingTests-1.0.typelib gschemas.compiled
+ @echo " CHECK Pyflakes"
+- @pyflakes $(top_srcdir)
++ pyflakes $(top_srcdir)
+ @echo " CHECK PEP8"
+- @pep8 --ignore=E501,E123 --repeat --show-source $(top_srcdir)
++ pep8 --ignore=E501,E123,E124,E127 --repeat --show-source $(top_srcdir)
+ $(RUN_TESTS_ENV_VARS) $(DBUS_LAUNCH) $(EXEC_NAME) $(PYTHON) -Wd -Werror::PendingDeprecationWarning -Werror::DeprecationWarning $(srcdir)/runtests.py
+
+ check.gdb:
diff --git a/pygobject-3.3.4-known-failures.patch b/pygobject-3.3.4-known-failures.patch
new file mode 100644
index 0000000..ef9e380
--- /dev/null
+++ b/pygobject-3.3.4-known-failures.patch
@@ -0,0 +1,11 @@
+diff -up pygobject-3.3.4/tests/test_gi.py.known-failures pygobject-3.3.4/tests/test_gi.py
+--- pygobject-3.3.4/tests/test_gi.py.known-failures 2012-08-08 21:47:11.770274588 -0400
++++ pygobject-3.3.4/tests/test_gi.py 2012-08-08 22:03:52.337206170 -0400
+@@ -2199,6 +2199,7 @@ class TestPropertiesObject(unittest.Test
+
+ self.assertAlmostEqual(obj.props.some_double, 42.0)
+
++ @unittest.expectedFailure
+ def test_strv(self):
+ self.assertEqual(self.obj.props.some_strv, [])
+ self.obj.props.some_strv = ['hello', 'world']
diff --git a/pygobject3.spec b/pygobject3.spec
index 8089d08..b32f078 100644
--- a/pygobject3.spec
+++ b/pygobject3.spec
@@ -8,11 +8,21 @@
%define python3_version 3.1
%endif
+%if 1
+ # Verbose build
+ %global verbosity V=1
+%else
+ # Quiet build
+ %global verbosity %{nil}
+%endif
+
+%global with_check 1
+
### Abstract ###
Name: pygobject3
Version: 3.3.4
-Release: 3%{?dist}
+Release: 4%{?dist}
License: LGPLv2+ and MIT
Group: Development/Languages
Summary: Python 2 bindings for GObject Introspection
@@ -20,6 +30,32 @@ URL: https://live.gnome.org/PyGObject
#VCS: git:git://git.gnome.org/pygobject
Source: http://ftp.gnome.org/pub/GNOME/sources/pygobject/3.3/pygobject-%{version}.tar.xz
+# Use this to help run "check"
+Source1: https://raw.github.com/jordansissel/xdotool/master/t/ephemeral-x.sh
+
+# Add these additional exclusions to the pep8 rules in "make check":
+# E124 closing bracket does not match visual indentation
+# E127 continuation line over-indented for visual indent
+# Not yet sent upstream
+Patch1: ignore-more-pep8-errors.patch
+
+# Mark some tests as known to fail; currently:
+# ======================================================================
+# FAIL: test_strv (test_gi.TestPropertiesObject)
+# ----------------------------------------------------------------------
+# Traceback (most recent call last):
+# File "/builddir/build/BUILD/pygobject-3.3.4/tests/test_gi.py", line 2205, in test_strv
+# self.assertEqual(self.obj.props.some_strv, ['hello', 'world'])
+# AssertionError: Lists differ: ['hello'] != ['hello', 'world']
+# Second list contains 1 additional elements.
+# First extra element 1:
+# world
+# - ['hello']
+# + ['hello', 'world']
+# ----------------------------------------------------------------------
+# Not yet sent upstream
+Patch2: pygobject-3.3.4-known-failures.patch
+
### Build Dependencies ###
BuildRequires: glib2-devel >= %{glib2_version}
@@ -33,6 +69,24 @@ BuildRequires: python3-cairo-devel
BuildRequires: cairo-gobject-devel
BuildRequires: pycairo-devel
+# Required by the upstream selftest suite:
+%if %{with_check}
+BuildRequires: pyflakes
+BuildRequires: python-pep8
+## for the Gdk and Gtk typelibs, used during the test suite:
+BuildRequires: gtk3
+## for use by ephemeral-x.sh:
+BuildRequires: xorg-x11-server-Xvfb
+BuildRequires: xterm
+BuildRequires: dejavu-sans-fonts
+BuildRequires: dejavu-sans-mono-fonts
+BuildRequires: dejavu-serif-fonts
+### for pkill:
+BuildRequires: procps-ng
+## for dbus-launch, used by test_gdbus:
+BuildRequires: dbus-x11
+%endif # with_check
+
# The cairo override module depends on this
Requires: pycairo
@@ -71,6 +125,8 @@ for use in Python 3 programs.
%prep
%setup -q -n pygobject-%{version}
+%patch1 -p1 -b .ignore-more-pep8-errors
+%patch2 -p1 -b .known-failures
%if 0%{?with_python3}
rm -rf %{py3dir}
@@ -84,14 +140,14 @@ find -name '*.py' | xargs sed -i '1s|^#!python|#!%{__python}|'
PYTHON=%{__python}
export PYTHON
%configure
-make %{?_smp_mflags}
+make %{?_smp_mflags} %{verbosity}
%if 0%{?with_python3}
pushd %{py3dir}
PYTHON=%{__python3}
export PYTHON
%configure
-make %{_smp_mflags}
+make %{_smp_mflags} %{verbosity}
popd
%endif # with_python3
@@ -102,15 +158,38 @@ rm -rf $RPM_BUILD_ROOT
pushd %{py3dir}
PYTHON=%{__python3}
export PYTHON
-make DESTDIR=$RPM_BUILD_ROOT install
+make DESTDIR=$RPM_BUILD_ROOT install %{verbosity}
popd
%endif # with_python3
-make DESTDIR=$RPM_BUILD_ROOT install
+make DESTDIR=$RPM_BUILD_ROOT install %{verbosity}
find $RPM_BUILD_ROOT -name '*.la' -delete
find $RPM_BUILD_ROOT -name '*.a' -delete
+%check
+
+%if %{with_check}
+# Run the selftests under an ephemeral X server (so that they can
+# initialize Gdk etc):
+
+# FIXME: disabled for python3
+# Currently this fails with python3 with:
+# File "/builddir/build/BUILD/python3-pygobject3-3.3.4-4.fc19/gi/__init__.py", line 23, in <module>
+# from ._gi import _API, Repository
+#ValueError: level must be >= 0
+%if 0
+pushd %{py3dir}
+PYTHON=%{__python3}
+export PYTHON
+%{SOURCE1} make DESTDIR=$RPM_BUILD_ROOT check %{verbosity}
+popd
+%endif # with_python3
+
+%{SOURCE1} make DESTDIR=$RPM_BUILD_ROOT check %{verbosity}
+
+%endif # with_check
+
%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig
@@ -144,6 +223,9 @@ find $RPM_BUILD_ROOT -name '*.a' -delete
%endif # with_python3
%changelog
+* Wed Aug 8 2012 David Malcolm <dmalcolm@redhat.com> - 3.3.4-4
+- add a %%check check; add V=1 to all make invocations
+
* Sat Aug 04 2012 David Malcolm <dmalcolm@redhat.com> - 3.3.4-3
- rebuild for https://fedoraproject.org/wiki/Features/Python_3.3